<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="primary"
                   size="small"
                   plain
                   v-if="permission.appoint_delete"
                   @click="handleDelete">确认发货
        </el-button>
        <el-button type="primary"
                   size="small"
                   @click="downLoadAppoint">下载
        </el-button>
      </template>
      <template slot-scope="scope" slot="menu">
        <el-button type="text"
                   size="small"
                   @click="goodsListView(scope.row.arrivalCode)">查看商品列表</el-button>
      </template>
    </avue-crud>
    <!--  商品列表dialog  -->
    <el-dialog title="商品列表"
               append-to-body
               :visible.sync="goodsBox"
               :before-close="handleClose"
               width="50%"
               heigh="30%">
      <avue-crud :option="appointGoodsOption"
                 :table-loading="goodsLoading"
                 :data="appointGoodsData"
                 :page.sync="goodsPage"
                 ref="grouponCrud"
                 @on-load="goodsOnLoad">
      </avue-crud>
    </el-dialog>
  </basic-container>

</template>

<script>
  import {getList, getDetail, add, update, shipments, goodsList, exportAppointGoods} from "@/api/distribution/appoint";
  import {mapGetters} from "vuex";
  import {appointGoodsOption} from "../../option/mall/appointGoodsOption"
  import {getToken} from '@/util/auth';

  export default {
    data() {
      return {
        form: {},
        query: {},
        state: '',
        loading: true,
        goodsBox: false,
        goodsLoading: false,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        arrivalCode: '',
        appointGoodsData: [],
        goodsPage: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        appointGoodsOption,
        option: {
          selectable:(row,index)=>{
            return row.state === 0;
          },
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          addBtn: false,
          viewBtn: true,
          delBtn: false,
          selection: true,
          searchSpan: 5,
          dialogClickModal: false,
          column: [
            {
              label: "供应商名称",
              labelWidth: 130,
              prop: "storeName",
              rules: [{
                required: true,
                message: "请输入供应商名称",
                trigger: "blur"
              }]
            },
            {
              label: "自提点名称",
              labelWidth: 130,
              prop: "takeName",
              rules: [{
                required: true,
                message: "请输入自提点名称",
                trigger: "blur"
              }]
            },
            {
              label: "自提点联系电话",
              labelWidth: 130,
              prop: "takeTel",
              rules: [{
                required: true,
                message: "自提点联系电话",
                trigger: "blur"
              }]
            },
            {
              label: "履约单状态",
              labelWidth: 130,
              prop: "state",
              searchLabelWidth: 130,
              change: ({value, column}) => {
                this.state = value
              },
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=appoint_state",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: false,
              display: true,
              rules: [{
                required: true,
                message: "选择状态",
                trigger: "blur"
              }]
            },
            {
              label: "团购标题",
              labelWidth: 130,
              prop: "grouponName",
              rules: [{
                required: true,
                message: "请输入团购标题",
                trigger: "blur"
              }]
            },
            {
              label: "团购结束时间",
              labelWidth: 130,
              prop: "grouponEndTime",
              rules: [{
                required: true,
                message: "请输入团购结束时间",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.appoint_add, false),
          viewBtn: this.vaildData(this.permission.appoint_view, false),
          delBtn: this.vaildData(this.permission.appoint_delete, false),
          editBtn: this.vaildData(this.permission.appoint_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {

      downLoadAppoint(){
        // Object.assign(params, this.query)
        // console.log(params, '111111111111111111');
        // exportAppointGoods(this.state)
        console.log('1111111111111111111111111')
        window.open(`/api/distribution/appoint/exportAppointGoods?${this.website.tokenHeader}=${getToken()}&state=${this.state}`);
        console.log('2222222222222222222222222')
        // let blob = new Blob(exportAppointGoods(this.state), { type: "application/vnd.ms-excel" })
        // let url = window.URL.createObjectURL(blob);
        // const link = document.createElement("a"); // 创建a标签
        // link.href = url;
        // link.download = "质量验收报告"; // 重命名文件
        // link.click();
        // URL.revokeObjectURL(url); // 释放内存
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },

      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },

      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择的履约单进行发货么?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return shipments(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          console.log(params, '----------------');
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },

      goodsListView(arrivalCode) {
        this.arrivalCode = arrivalCode;
        this.goodsOnLoad(this.goodsPage)
        this.goodsBox = true;
      },
      handleClose() {
        this.goodsBox = false;
      },
      goodsOnLoad(page){
        console.log(this.arrivalCode, '------arrivalCode---------');
        this.goodsLoading = true;
        goodsList(page.currentPage, page.pageSize, this.arrivalCode).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.appointGoodsData = data.records;
          this.goodsLoading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
